#include "std.mi"
#include "pldir.mi"

Function setTempText(String txt);
Function emptyTempText();

Global Text Songticker, thetimer;
Global Slider Volbar, Seeker;
Global Int Seeking, playinganim;
Global Group pgroup;
Global String currentSongTickerOption, lastSongTickerOption, currentMiniPlayerOption, lastMiniPlayerOption, currentOptions;
Global Timer theChecker;
Global GuiObject miniplayer;

Class GuiObject HintObject;

Global HintObject Play, Stop, Previous, Next, Pause, closew, cm;

System.onScriptLoaded() {
	pgroup = System.getScriptGroup();

	Songticker = pgroup.getObject("songticker");
	miniplayer = pgroup.getObject("MiniPlayer");
	thetimer = pgroup.getObject("thetimer");
	Volbar = pgroup.getObject("volume");
	Seeker = pgroup.getObject("seeker");

	Play = pgroup.getObject("Play");
	Pause = pgroup.getObject("Pause");
	Stop = pgroup.getObject("Stop");
	Next = pgroup.getObject("Next");
	Previous = pgroup.getObject("Previous");
	closew = pgroup.getObject("Close");
	cm = pgroup.getObject("controlmenu");

	currentOptions = System.getPrivateString("WINyaMP3", "theoptions", "1_1");
	currentSongTickerOption = System.strleft(currentOptions, 1);
	currentMiniPlayerOption = System.strright(currentOptions, 1);
	lastMiniPlayerOption = currentMiniPlayerOption;
	if(currentMiniPlayerOption == "1"){
		miniplayer.setXmlParam("y", "0");
		Songticker.setXmlParam("ticker", currentSongTickerOption);
		lastSongTickerOption = currentSongTickerOption;
		Songticker.setXmlParam("display", "songname");
		thetimer.setXmlParam("display", "time");
	} else {
		Songticker.setXmlParam("ticker", "0");
	}
	theChecker = new Timer;
	theChecker.setDelay(150);
	theChecker.start();
}

System.onScriptUnloading(){
	theChecker.stop();
}

theChecker.onTimer() {
	currentOptions = System.getPrivateString("WINyaMP3", "theoptions", "1_1");
	currentSongTickerOption = System.strleft(currentOptions, 1);
	currentMiniPlayerOption = System.strright(currentOptions, 1);
	if(currentMiniPlayerOption != lastMiniPlayerOption){
		lastMiniPlayerOption = currentMiniPlayerOption;
		if(currentMiniPlayerOption == "1"){
			miniplayer.setXmlParam("y", "0");
			lastSongTickerOption = currentSongTickerOption;
			Songticker.setXmlParam("ticker", currentSongTickerOption);
			Songticker.setXmlParam("display", "songname");
			thetimer.setXmlParam("display", "time");
		} else {
			miniplayer.setXmlParam("y", "-45");
			Songticker.setXmlParam("ticker", "0");
			Songticker.setXmlParam("display", "nothing");
			thetimer.setXmlParam("display", "nothing");
		}
	} else {
		if(currentSongTickerOption != lastSongTickerOption && currentMiniPlayerOption == "1"){
			lastSongTickerOption = currentSongTickerOption;
			Songticker.setXmlParam("ticker", currentSongTickerOption);
		}
	}

}

Songticker.onLeftButtonDblClk(int x, int y) {
	PlDir.showCurrentlyPlayingEntry();
}

Volbar.onSetPosition(int p) {
	Float f;
	f = p;
	f = f / 255 * 100;
	setTempText("Volume: " + System.integerToString(f) + "%");
}

Volbar.onSetFinalPosition(int p) {
	Songticker.setAlternateText("");
}

Seeker.onSetPosition(int p) {
	if (seeking) {
		Float f;
		f = p;
		f = f / 255 * 100;
		Float len = getPlayItemLength();
		if (len != 0) {
			int np = len * f / 100;
			setTempText("Seek to " + integerToTime(np) + " / " + integerToTime(len) + " (" + integerToString(f) + "%)");
		}
	}
}

Seeker.onLeftButtonDown(int x, int y) {
	seeking = 1;
}

Seeker.onLeftButtonUp(int x, int y) {
	seeking = 0;
	setTempText("");
}

Seeker.onSetFinalPosition(int p) {
	Songticker.setAlternateText("");
}


HintObject.onLeftButtonDown(int x, int y) {
	if (HintObject == Play) setTempText("Play");
	else if (HintObject == Stop) setTempText("Stop");
	else if (HintObject == Pause) setTempText("Pause");
	else if (HintObject == Next) setTempText("Next");
	else if (HintObject == Previous) setTempText("Previous");
	else if (HintObject == closew) setTempText("Close Window");
	else if (HintObject == cm) setTempText("Control Menu");
}

HintObject.onLeftButtonUp(int x, int y) {
	emptyTempText();
}

setTempText(String txt) {
	Songticker.setAlternateText(txt);
}

emptyTempText() {
	Songticker.setAlternateText("");
}
