#include "std.mi"

Global ToggleButton songtickertbutton, miniplayertbutton;
Global String currentSongTickerOption, currentMiniPlayerOption, currentOptions;
Global GuiObject mainticker, shadedticker, songtickerbutton, miniplayerbutton;
Global Layout mainwindow, mainwindowShaded;
Global Group scriptgroup, mainwindowGroup;

System.onScriptLoaded() {
	scriptgroup = System.getScriptGroup();
	mainwindow = System.getContainer("main").getLayout("Yamp");
	mainwindowShaded = System.getContainer("main").getLayout("Bar");

	mainwindowGroup = mainwindow.getObject("player.normal.playbuttons");

	mainticker = mainwindowGroup.getObject("songticker");
	shadedticker = mainwindowShaded.getObject("songticker");
	songtickerbutton = scriptgroup.getObject("songtickerbtn");
	songtickertbutton = scriptgroup.getObject("songtickertbtn");
	miniplayerbutton = scriptgroup.getObject("miniplayerbtn");
	miniplayertbutton = scriptgroup.getObject("miniplayertbtn");

	currentOptions = System.getPrivateString("WINyaMP3", "theoptions", "1_1");
	currentSongTickerOption = System.strleft(currentOptions, 1);
	currentMiniPlayerOption = System.strright(currentOptions, 1);
	mainticker.setXmlParam("ticker", currentSongTickerOption);
	shadedticker.setXmlParam("ticker", currentSongTickerOption);
	currentOptions = currentSongTickerOption+"_"+currentMiniPlayerOption;
	System.setPrivateString("WINyaMP3", "theoptions", currentOptions);
	songtickertbutton.setActivated(System.stringToInteger(currentSongTickerOption));
	miniplayertbutton.setActivated(System.stringToInteger(currentMiniPlayerOption));
}

songtickerbutton.onLeftButtonDown(int x, int y) {
	if(currentSongTickerOption == "1"){
		mainticker.setXmlParam("ticker", "0");
		shadedticker.setXmlParam("ticker", "0");
		songtickertbutton.setActivated(0);
		currentSongTickerOption = "0";
		currentOptions = currentSongTickerOption+"_"+currentMiniPlayerOption;
		System.setPrivateString("WINyaMP3", "theoptions", currentOptions);
	} else {
		mainticker.setXmlParam("ticker", "1");
		shadedticker.setXmlParam("ticker", "1");
		songtickertbutton.setActivated(1);
		currentSongTickerOption = "1";
		currentOptions = currentSongTickerOption+"_"+currentMiniPlayerOption;
		System.setPrivateString("WINyaMP3", "theoptions", currentOptions);
	}
}

miniplayerbutton.onLeftButtonDown(int z, int a) {
	if(currentMiniPlayerOption == "1"){
		miniplayertbutton.setActivated(0);
		currentMiniPlayerOption = "0";
		currentOptions = currentSongTickerOption+"_"+currentMiniPlayerOption;
		System.setPrivateString("WINyaMP3", "theoptions", currentOptions);
	} else {
		miniplayertbutton.setActivated(1);
		currentMiniPlayerOption = "1";
		currentOptions = currentSongTickerOption+"_"+currentMiniPlayerOption;
		System.setPrivateString("WINyaMP3", "theoptions", currentOptions);
	}
}

